#include "ampdec.h"
#include "cstdio"

int
main( int argc, char** argv )
{
    if( argc != 3 ) {
	puts( "usage: decode <in.mp3> <out.raw>" );
	return 0;
    }
	
    FILE* in;
    if( !(in = fopen( argv[1], "rb" ) ) ) {
	printf( "Error: could not open file %s!\n", argv[1] );
	return -1;
    }
    
    ampegdecoder dec;
    int freq, stereo;
    if( dec.open( in, freq, stereo, 1, 0, 0 ) < 0 ) {
	puts( "Error: could not open decoder!" );
	fclose( in );
	return -2;
    }
    printf("MP3 opened. freq = %i, stereo=%i\n", freq, stereo );

    FILE* of = fopen( argv[2], "wb" );
    if( !of ) {
	printf( "Error: could not create output file %s!\n", argv[2] );
	dec.close();
	fclose( in );
	return -3;
    }    
    
    char* buf = new char[16384];
    int size;

    while( ( size = dec.read( buf, 16384 ) ) > 0 )
	if( fwrite( buf, 1, 16384, of ) < 16384 ) {
	    puts( "Error: Disk full!" );
	    fclose( of );
	    delete buf;
	    dec.close();
	    fclose( in );	    
	    return -4;
	}
    
    fclose( of );
    delete buf;
    dec.close();
    fclose( in );
    return 0;
}

